<?php

namespace xenMade\STWM\Util;

class Helper
{
    public static function removeSTWMDirectory($dirPath = null)
    {
        if($dirPath === null)
            $dirPath = \XF\Util\File::canonicalizePath(\XF::app()->config('internalDataPath') . DIRECTORY_SEPARATOR . 'stwm_watermarks');

        $paths = glob(sprintf('%s/*', $dirPath));

        foreach($paths as $path)
        {
            if (is_dir($path))
            {
                self::removeSTWMDirectory($path);
            }
            else
            {
                @unlink($path);
            }
        }

        return true;
    }

    public static function generateWatermark($attachment)
    {
        $watermark = null;

        if($attachment instanceof \XF\Entity\Attachment)
        {
            $areas = \XF::options()->stwm_areas;
            $contentType = $attachment->content_type;

            $area = $areas['unknow'];

            if(isset($areas[$contentType]))
            {
                $area = $areas[$contentType];
            }

            $availableImageTypes = \XF::options()->stwm_availableImageTypes;

            $ext = $attachment->getExtension();
            $ext = str_replace('jpeg', 'jpg', $ext);

            if(
                $attachment &&
                \XF::visitor()->hasPermission('general', 'stwm_displayWatermark') &&
                $area &&
                !empty($availableImageTypes[$ext])
            )
            {
                if($attachment->ignoreForum() == true)
                {
                    $watermark = new \xenMade\STWM\Util\Watermark($attachment);

                    if($watermark->status != true)
                    {
                        $watermark = null;
                    }
                }
            }
        }

        return $watermark;
    }
}