<?php

namespace xenMade\STWM\XF\Entity;

class Attachment extends XFCP_Attachment
{
    protected $_nodeIds = null;

    public function ignoreForum(&$error = null)
    {
        if ($this->temp_hash || !$this->content_type)
        {
            return true;
        }

        if($this->content_type != 'post')
            return true;

        /** @var \XF\Repository\Attachment $attachmentRepo */
        $attachmentRepo = $this->repository('XF:Attachment');
        $handler = $attachmentRepo->getAttachmentHandler($this->content_type);
        if (!$handler)
        {
            return true;
        }

        $container = $handler->getContainerEntity($this->content_id);
        if (!$container)
        {
            return true;
        }

        if(empty($container->Thread['node_id']))
        {
            return true;
        }

        $nodeId = $container->Thread['node_id'];

        return $this->ignoreForumById($nodeId);
    }

    protected function ignoreForumById($nodeId)
    {
        $nodeId = (int)$nodeId;

        if($this->_nodeIds === null)
            $this->_nodeIds = \XF::options()->stwm_forums;

        if($nodeId)
        {
            if(empty($this->_nodeIds))
                $this->_nodeIds[0] = 0;

            if(isset($this->_nodeIds[0]) && $this->_nodeIds[0] == 0 && count($this->_nodeIds) <= 1)
            {
                return true;
            }

            if(!in_array($nodeId, $this->_nodeIds))
            {
                return false;
            }
        }

        return true;
    }
}
if (false)
{
    class XFCP_Attachment extends \XF\Entity\Attachment {}
}