<?php

namespace xenMade\STWM\XF\Entity;

class AttachmentData extends XFCP_AttachmentData
{
    public function getAbstractedSTWMDataPath()
    {
        return $this->_getAbstractedSTWMDataPath(
            $this->data_id,
            $this->file_path,
            $this->file_hash
        );
    }

    protected function _getAbstractedSTWMDataPath($dataId, $filePath, $fileHash)
    {
        $group = floor($dataId / 1000);

        if ($filePath)
        {
            $placeholders = [
                '%INTERNAL%' => 'internal-data://', // for legacy
                '%DATA%' => 'data://', // for legacy
                '%DATA_ID%' => $dataId,
                '%FLOOR%' => $group,
                '%HASH%' => $fileHash
            ];
            $path = strtr($filePath, $placeholders);
            $path = str_replace(':///', '://', $path); // writing %INTERNAL%/path would cause this

            return $path;
        }
        else
        {
            return sprintf('internal-data://stwm_watermarks/%d/%d-%s.data',
                $group,
                $dataId,
                $fileHash
            );
        }
    }

}
if (false)
{
    class XFCP_AttachmentData extends \XF\Entity\AttachmentData {}
}