<?php

namespace xenMade\STWM\XF\Pub\View\Attachment;

class View extends XFCP_View
{
    public function renderRaw()
    {
        if(!empty($this->params['watermark']->outputImage))
        {
            /** @var \XF\Entity\Attachment $attachment */
            $attachment = $this->params['attachment'];

            if (!empty($this->params['return304']))
            {
                $this->response
                    ->httpCode(304)
                    ->removeHeader('last-modified');

                return '';
            }

            $this->response
                ->setAttachmentFileParams($attachment->filename, $attachment->extension)
                ->header('ETag', '"' . $attachment->attach_date . '"');

            $fileSize = @filesize($this->params['watermark']->outputImage);

            if($fileSize > 0)
            {
                $resource = \XF::fs()->readStream($attachment->Data->getAbstractedSTWMDataPath());
                return $this->response->responseStream($resource, $fileSize);
            }
        }

        return parent::renderRaw();
    }
}
if (false)
{
    class XFCP_View extends \XF\Pub\View\Attachment\View {}
}